EDIT - task #5285

Use Vaadin Spring Add-on
09/22/2015 09:48 AM - Andreas Mdller

Status: Closed Start date:

Priority: New Due date:

Assignee: Andreas Kohlbecker % Done: 0%
Category: cdm-vaadin Estimated time: 0:00 hour
Target version: Release 4.7

Severity: normal

Description

Vaadin Spring Addon

The Vaadin Spring integration library helps you build amazing Vaadin based user interfaces on top of your high quality Spring based
enterprise backend. Your Ul classes become Spring managed beans, allowing you to autowire Spring based services directly into
your Ul code.

Links:

e Vaadin Spring API
¢ Vaadin Spring Tutorial
o Example application
e https://vaadin.com/wiki/-/wiki/Main/Spring%20Integration (on Vaadin 6)
e https://vaadin.com/wiki/-/wiki/Main/Vaadin+Spring

The features of Vaadin Spring include:

e First class support for Spring Boot

¢ Vaadin Ul, View and component classes can be Spring managed beans and utilise the 1oC container provided by Spring core
e @SpringUl annotated classes are automatically published, no need to manually introduce a servlet

¢ Vaadin Navigator support for View classes annotated with @SpringView *Scopes for Vaadin Uls and Views

e Using the @Autowired annotation in Vaadin Ul code

¢ Push support

TODO:
THE BOOK OF VAADIN (2016-04-19) IS OUTDATED REGARDING VAADIN-SPRING!

Therefore the below conclusions may not be up to date.

DONE also all subtasks below
o CdmVaadinConversationalServlet: needs to extend SpringVaadinServlet
o Ul Classes:
= The inner VaadinServlet classes of the Ul Classes need to extend SpringVaadinServlet
= the @VaadinServletConfiguration needs to be removed. Q: How can the widgetset be configured? (The other
attributes are obsolete.) A: Use the @WidgetSet at the type level.

e The @Scope annotation at the DetailWindow must be replaced by @ViewScope or by @UIScope if this annotation is really still
relevant.

¢ A couple of Views are evaluating the Spring Security Context. These classes are using the static method
SecurityContextHolder.getContext() to get the context. This can most probably be replaced by ViewAccessControl or
ViewlInstanceAccessControl, which can restrict access to the view either before or after a view instance is created. (See Book of
Vaadin 12.18.7. Access Control )

e The CdmSpringContextHelper no longer needs to provide the Springbeans by the bean id when using vaadin-spring. Through
spring-vaadin injection of spring beans works. Springbeans can be @Autowired. The CdmSpringContextHelper should be
replaced by the Repository View addressed in #3320 - | attempted to refactor cdm-vaading accordingly but giving up on this,
due to the complexity and variety of the 'design patterns' that have been used: cdm-vaadin|a735bbb

Related issues:
https://vaadin.com/api/vaadin-spring/
http://vaadin.github.io/spring-tutorial/
https://github.com/Vaadin/spring-tutorial
https://vaadin.com/wiki/-/wiki/Main/Spring%20Integration
https://vaadin.com/wiki/-/wiki/Main/Vaadin+Spring
https://dev.e-taxonomy.eu/redmine/issues/3320
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/cdm-vaadin/revisions/a735bbbfccc284e24f355551d2496cd15e790243

Related to EDIT - task #3320: Correct use of CdmApplicationDefaultConfiguration New

Associated revisions

Revision fb70a9a7 - 02/08/2017 10:58 AM - Andreas Kohlbecker
ref #5285 adding vaadin-spring to the pom.xml

Revision 029f979a - 02/08/2017 01:34 PM - Andreas Kohlbecker
ref #5285 replacing VaadinServlet by SpringVaadinServlet

Revision fd9cf932 - 02/09/2017 04:38 PM - Andreas Kohlbecker
ref #5285 SpringUI configuration working

e @SpringUl added and configured
¢ theme harmonization as has as possible without causing glitches
e updating to vaadin 7.7.7

Revision ad9b6d23 - 02/10/2017 04:42 PM - Andreas Kohlbecker

ref #5285 addon structure for cdmlib-remote extensions like cdm-vaadin with autodetection
Revision a735bbbf - 02/15/2017 09:35 AM - Andreas Kohlbecker
ref #5285 attempt to avoid using the CdmSpringContextHelper

using DI to get rid of CdmSpringContextHelper, but got stuck due to the complexity and variety of the 'design patterns' that have been used.

History

#1 - 01/05/2017 10:45 AM - Andreas Kohlbecker

- Description updated

UPDATE:

Vaadin, the polyglot framework for building web apps with Ul components, released version 1.1 of their Vaadin Spring project.
There are two new features related to Vaadin’s Navigator class and View interface:

* A new SpringNavigator class
¢ A new @SpringViewDisplay annotation

The SpringNavigator class “greatly simplifies the configuration of views” and the @SpringViewDisplay annotation “can be used to mark the target
Vaadin component, where your views should actually be displayed.”

There were also a number of bug fixes including serialization of HTTP sessions using Vaadin Spring.
see

https://www.infog.com/news/2016/12/vaadin-releases-vaadin-spring?utm_source=infogWeeklyNewsletter&utm_medium=WeeklyNL_EditorialContent
java&utm_campaign=01032017news

Also potentially interesting is the webinar mentioned in that news post: https://vaadin.com/blog/-/blogs/spring-boot-a-perfect-platform-for-a-vaadin-ui

#2 - 01/05/2017 01:42 PM - Andreas Miiller

- Assignee changed from Cherian Mathew to Andreas Kohlbecker

#3 - 02/08/2017 08:49 AM - Andreas Kohlbecker

- Subject changed from Use Vaading Spring to Use Vaading Spring Add-on
- Description updated

- Status changed from New to In Progress

- Target version changed from Vaadin Taxon Concept Editor to Release 4.6

#4 - 02/08/2017 09:02 AM - Andreas Kohlbecker

- Description updated

#5 - 02/08/2017 09:10 AM - Andreas Kohlbecker

- Description updated
https://www.infoq.com/news/2016/12/vaadin-releases-vaadin-spring?utm_source=infoqWeeklyNewsletter&utm_medium=WeeklyNL_EditorialContent_java&utm_campaign=01032017news
https://www.infoq.com/news/2016/12/vaadin-releases-vaadin-spring?utm_source=infoqWeeklyNewsletter&utm_medium=WeeklyNL_EditorialContent_java&utm_campaign=01032017news
https://vaadin.com/blog/-/blogs/spring-boot-a-perfect-platform-for-a-vaadin-ui

#6 - 02/08/2017 09:18 AM - Andreas Kohlbecker

- Private changed from Yes to No

#7 - 02/08/2017 09:21 AM - Andreas Kohlbecker
- Description updated

#8 - 02/08/2017 09:27 AM - Andreas Kohlbecker
- Description updated

#9 - 02/08/2017 09:28 AM - Andreas Kohlbecker
- Description updated

#10 - 02/08/2017 09:46 AM - Andreas Kohlbecker
- Description updated

#11 - 02/08/2017 10:27 AM - Andreas Miiller

- Subject changed from Use Vaading Spring Add-on to Use Vaadin Spring Add-on

#12 - 02/08/2017 11:24 AM - Andreas Kohlbecker

- Subject changed from Use Vaadin Spring Add-on to Use Vaading Spring Add-on

- Description updated

#13 - 02/08/2017 11:25 AM - Andreas Kohlbecker

- Subject changed from Use Vaading Spring Add-on to Use Vaadin Spring Add-on

#14 - 02/08/2017 11:35 AM - Andreas Kohlbecker

- Description updated

#15 - 02/08/2017 11:58 AM - Andreas Kohlbecker

- Description updated

#16 - 02/08/2017 12:01 PM - Andreas Kohlbecker

- Description updated

#17 - 02/08/2017 12:04 PM - Andreas Kohlbecker

- Description updated

#18 - 02/08/2017 01:24 PM - Andreas Kohlbecker

- Description updated

#19 - 02/08/2017 01:39 PM - Andreas Kohlbecker

- Description updated

#20 - 02/14/2017 08:32 AM - Andreas Kohlbecker

- Related to task #3320: Correct use of CdmApplicationDefaultConfiguration added

#21 - 02/14/2017 08:35 AM - Andreas Kohlbecker

- Description updated

#22 - 02/15/2017 09:38 AM - Andreas Kohlbecker

- Description updated

#23 - 03/17/2017 08:10 AM - Andreas Miiller

- Target version changed from Release 4.6 to Release 4.7

#24 - 05/10/2017 09:06 PM - Andreas Kohlbecker
- Status changed from In Progress to Closed
